<?php

namespace Picea\Extension;

use Picea\Compiler\Context;

class PrintExtension implements Extension {

    public array $token = [ "print", "print.safe", "print.raw" ];
    
    public int $flag = \ENT_QUOTES;

    public string $encoding;

    public bool $doubleEncode = true;

    public function __construct() {
        $this->encoding = ini_get("default_charset");
    }

    public function parse(/*\Picae\Compiler\Context*/ &$context, ?string $arguments, string $token) : string
    {
        switch($token) {
            case 'print':
            case "print.safe":
                return "<?php echo htmlspecialchars(sprintf($arguments), {$this->flag}, '{$this->encoding}', " . ($this->doubleEncode ? "true" : "false") . ") ?>";

            case "print.raw":
                return "<?php echo sprintf($arguments) ?>";
        }
    }
    
}
